# -*- encoding: utf-8 -*-
#原画ライセンスグループ
require 'spec_helper'

describe OriginalPictureLicenseGroup do
  before do
    FactoryGirl.create :admin
    @user = FactoryGirl.create( :user_yas)
    @author = @user.author
    @artist = FactoryGirl.create :artist_yas, :author_id => @author.id
    @other_user = FactoryGirl.create( :user_yas)
    @other_author = @other_user.author
    @other_artist = FactoryGirl.create :artist_yas, :author_id => @other_author.id
    @sp = FactoryGirl.create :system_picture
    @lg = FactoryGirl.create :license_group
    @license = FactoryGirl.create :license, :license_group_id => @lg.id, :system_picture_id => @sp.id
    @op = FactoryGirl.create :original_picture, :artist_id => @artist.id
  end
  
  describe '検証に於いて' do
    before do
    end
    
    it 'オーソドックスなデータなら通る' do
      @ol = FactoryGirl.build :oplg, :original_picture_id => @op.id, :license_group_id => @lg.id
      @ol.should be_valid
    end
    
    context 'original_picture_idを検証するとき' do
      before do
        @ol = FactoryGirl.build :oplg, :original_picture_id => @op.id, :license_group_id => @lg.id
      end
      it 'テストデータの確認' do
        @ol.original_picture_id = @op.id
        @ol.should be_valid
      end
      it 'nullなら失敗する' do
        @ol.original_picture_id = nil
        @ol.should_not be_valid
      end
      it '数値でなければ失敗する' do
        @ol.original_picture_id = 'a'
        @ol.should_not be_valid
      end
      it '存在する原画でなければ失敗する' do
        @ol.original_picture_id = 0
        @ol.should_not be_valid
      end
    end
    context 'license_group_idを検証するとき' do
      before do
        @ol = FactoryGirl.build :oplg, :original_picture_id => @op.id, :license_group_id => @lg.id
      end
      it 'テストデータの確認' do
        @ol.license_group_id = @lg.id
        @ol.should be_valid
      end
      it 'nullなら失敗する' do
        @ol.license_group_id = nil
        @ol.should_not be_valid
      end
      it '数値でなければ失敗する' do
        @ol.license_group_id = 'a'
        @ol.should_not be_valid
      end
      it '存在するライセンスグループでなければ失敗する' do
        @ol.license_group_id = 0
        @ol.should_not be_valid
      end
    end
  end
  describe '補充に於いて' do
    it '原画idを補充している' do
      @ol = OriginalPictureLicenseGroup.new
      @ol.original_picture_id = nil
      @ol.supply_default 5
      @ol.original_picture_id.should eq 5
    end
  end
end
